;----------------------------------------------------------------------------
; ted.asm          version 0.1          copyright (c) 1997, brioche/aspirine
;----------------------------------------------------------------------------
; some kind of tiny text editor (written in about half an hour)
;----------------------------------------------------------------------------
; this proggy assumes that all the common registers are set to zero and that
; the direction flag is cleared.
; nothing more to say about this source except that it has been assembled
; with borland tasm 3.1 and linked with tlink 5.1 (just type go.bat)
;----------------------------------------------------------------------------
; note: i/o errors are handled but if you put an already existing filename 
; on command, your file will be crashed and you'll hate me and my stupid
; size optimized assembler programs :) btw, it is certainly possible to get
; rid of some bytes here and there so if you have soe time to waist, you can 
; try kicking out some of them: it's so entertaining! :)
;----------------------------------------------------------------------------
; there are plenty of comments even if real coders don't need comments! :)
;----------------------------------------------------------------------------
; this is freeware but e-mails are welcome!     106146.1452@compuserve.com
;----------------------------------------------------------------------------

		.286
		.model  tiny

code            segment public use16

		assume  cs:code, ds:code, es:code, ss:code
		org     100h
		
start:          ;-- first we process command line argument

		mov     di, 81h                         ;command line offset
		mov     cl, ds:[di-1]                   ;command line length
		mov     bx, di
		add     bx, cx                          ;end of command line
		mov     dx, di
		mov     al, ' '
		repe    scasb                           ;is there an argument?
		
		or      cl, cl
		jz      error
		
		mov     byte ptr [bx], 0                ;make it asciiz
		mov     dx, di
		dec     dx				;dx points on filename

		;-- we want DOS to create a new file 

		mov     ah, 3ch                         ;create file (handle)
		xor     cx, cx                          ;file attribute
		int     21h
		jc      error                           ;exit on error
		mov     bp, ax                          ;store handle in bp

		;-- here's the main editor's loop :)

editloop:       mov     ah, 0ah                         ;get stream from stdin
		mov     dx, offset buff                         
		int     21h
		inc     dx                              
		inc     dx                              ;points to ascii string
		mov     bx, dx
		mov     cl, [bx-1]                      ;get length of input
		or      cl, cl                          ;empty string?
		jz      byebye
		mov     si, cx
		mov     word ptr [bx+si], 0a0dh         ;pad with CR+LF chars
		inc     cx
		inc     cx                              ;2 bytes more for crlf
		mov     ah, 40h                         ;write cx bytes in file
		mov     bx, bp                          ;specify file handle
		int     21h
		jc      error                           ;exit on write error
		jmp     editloop
		
byebye:         mov     ah, 3eh                         ;close handle
		mov     bx, bp
		int     21h
		ret					;au revoir TED!

error:          mov     ah, 9                           ;print some explicit
		mov     dx, offset errmsg               ;message to the user
		int     21h                             ;funny, he! :)
		ret

;-- data --------------------------------------------------------------------

errmsg          db      'Error$'			;neat error message
buff            db      81				;buffer length
		db	0				;zero data start here!
		db      81 dup( 0 )

code            ends

		end     start                           ;eat this! :)
